#include <ReArchive/ReArchive.h>
#include <iostream>

int main() {
    ReArchive::FileTable running_tally;

    if(std::filesystem::exists("test.rsa"))
        std::filesystem::remove("test.rsa");
    
    if (!ReArchive::CreateArchive("test.rsa"))
        return -1;
    std::string some_string = "some other string0.";
    if (!ReArchive::WriteFile("test.rsa", "assets/test0.png", reinterpret_cast<const unsigned char *>(some_string.data()), some_string.size(), &running_tally))
        return -1;

    some_string = "some other string1.";
    if (!ReArchive::WriteFile("test.rsa", "assets/test1.png", reinterpret_cast<const unsigned char *>(some_string.data()), some_string.size(), &running_tally))
        return -1;


    auto retrieved = ReArchive::ReadFile("test.rsa", "assets/test0.png");
    std::cout << std::string( retrieved.begin(), retrieved.end()) << std::endl;

    if (!ReArchive::EraseFile("test.rsa", "assets/test0.png", &running_tally))
        return -1;

    auto retrieved2 = ReArchive::ReadFile("test.rsa", "assets/test1.png");
    std::cout << std::string( retrieved2.begin(), retrieved2.end()) << std::endl;

    for (auto& e : running_tally.GetEntries())
        std::cout << e.second.Path() << std::endl;

    ReArchive::FileTable copy = running_tally;
}